"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var merge = require("lodash/merge");
var App_1 = require("./App");
function mergeOptions(createAppOptions, constructorOptions) {
    var mergedOptions = merge({}, createAppOptions, constructorOptions);
    // keep lifecycle methods from both
    // `createApp(options)` and `new App(options)`
    [
        'initialize',
        'beforeDestroy',
    ].forEach(function (cbName) {
        if (typeof createAppOptions[cbName] === 'function' &&
            typeof constructorOptions[cbName] === 'function') {
            mergedOptions[cbName] = function lifecycleCb() {
                createAppOptions[cbName].call(this);
                constructorOptions[cbName].call(this);
            };
        }
    });
    return mergedOptions;
}
function createApp(options) {
    var NewApp = /** @class */ (function (_super) {
        __extends(NewApp, _super);
        function NewApp(opts) {
            if (opts === void 0) { opts = {}; }
            return _super.call(this, mergeOptions(options, opts)) || this;
        }
        return NewApp;
    }(App_1.App));
    if (typeof options.name !== 'undefined') {
        Object.defineProperty(NewApp, 'frintAppName', {
            value: options.name,
            configurable: true,
        });
    }
    return NewApp;
}
exports.default = createApp;
//# sourceMappingURL=createApp.js.map